# Appendix III: Using Bitcoin Regtest 

The majority of this course presumes that you will either use the Mainnet or Testnet. However, those aren't the only choices. While developing Bitcoin applications, you might want to keep your applications isolated from these public blockchains. You can create a Blockchain from scratch using the Regtest, which has one other major advantage over Testnet: you choose when to create new blocks, so you have complete control over the environment.

## Objectives for This Chapter

After working through this chapter, a developer will be able to:

   * Create a blockchain from scratch
   * Use that blockchain to interact with `bitcoind` in a private way
   * Use that blockchain to generate blocks and get the rewards

Supporting objectives include the ability to:

   * Understand the advantages of Regtest
   
## Table of Contents
  * [Section One: Starting the Regtest](A3_1_Starting_the_Regtest.md)
  * [Section Two: Mining with Regtest](A3_2_Mining_with_Regtest.md)
  * [Section Three: Testing with Regtest](A3_3_Testing_with_Regtest.md)
